searchNodes=[{"doc":"Application module extended functions.","ref":"ApplicationX.html","title":"ApplicationX","type":"module"},{"doc":"List all available applications excluding system ones.This function is save to run in Mix.Tasks.ExampleSince :common_x does not have any dependencies:iex&gt; ApplicationX.applications [:common_x]","ref":"ApplicationX.html#applications/0","title":"ApplicationX.applications/0","type":"function"},{"doc":"List all dependant applications excluding system ones. Does includes the given application.This function is save to run in Mix.Tasks.ExampleSince :common_x does not have any dependencies:iex&gt; ApplicationX.applications(:common_x) [:common_x]Duplicates are ignored and only returned once:iex&gt; ApplicationX.applications([:common_x, :common_x]) [:common_x]Unknown applications are safe, but returned:iex&gt; ApplicationX.applications(:fake) [:fake]","ref":"ApplicationX.html#applications/1","title":"ApplicationX.applications/1","type":"function"},{"doc":"The atom of the current main application.For example take an application called :my_app, which includes the :my_dep dependencies, which has :common_x as dependency.So::my_app ├── ... └── :my_dep ├── ... └── :common_xIn that scenario calling ApplicationX.main will return :my_app both for code in :my_app and :my_dep.Examplesiex&gt; ApplicationX.main :common_x","ref":"ApplicationX.html#main/0","title":"ApplicationX.main/0","type":"function"},{"doc":"The mix configuration of the current main application.For example take an application called :my_app, which includes the :my_dep dependencies, which has :common_x as dependency.So::my_app ├── ... └── :my_dep ├── ... └── :common_xIn that scenario calling ApplicationX.main will return the mix config of :my_app both for code in :my_app and :my_dep.Examplesiex&gt; config = ApplicationX.main_project iex&gt; config[:app] :common_x iex&gt; config[:description] &quot;Extension of common Elixir modules.&quot;","ref":"ApplicationX.html#main_project/0","title":"ApplicationX.main_project/0","type":"function"},{"doc":"Get the current Mix environment.Exampleiex&gt; ApplicationX.mix_env :test","ref":"ApplicationX.html#mix_env/0","title":"ApplicationX.mix_env/0","type":"function"},{"doc":"List all available modules excluding system ones.This function is save to run in Mix.Tasks.ExampleSince :common_x does not have any dependencies:iex&gt; ApplicationX.modules [ApplicationX, CodeX, CommonX, EnumX, MacroX, MapX]","ref":"ApplicationX.html#modules/0","title":"ApplicationX.modules/0","type":"function"},{"doc":"List all available modules for the given app[s] and dependencies of those apps. This excludes system modules.This function is save to run in Mix.Tasks.ExampleNormally system modules are excluded, but can be added by manually passing the respective system application:iex&gt; ApplicationX.modules(:logger) [Logger, Logger.App, Logger.BackendSupervisor, Logger.Backends.Console, Logger.Config, Logger.Counter, Logger.Filter, Logger.Formatter, Logger.Handler, Logger.Translator, Logger.Utils, Logger.Watcher]Duplicate applications are ignored:iex&gt; ApplicationX.modules([:logger, :logger]) [Logger, Logger.App, Logger.BackendSupervisor, Logger.Backends.Console, Logger.Config, Logger.Counter, Logger.Filter, Logger.Formatter, Logger.Handler, Logger.Translator, Logger.Utils, Logger.Watcher]Unknown applications are safe to pass:iex&gt; ApplicationX.modules(:fake) []","ref":"ApplicationX.html#modules/1","title":"ApplicationX.modules/1","type":"function"},{"doc":"Code module extended functions.","ref":"CodeX.html","title":"CodeX","type":"module"},{"doc":"Ensures the given module is compiled.Similar to Code.ensure_compiled/1, but returns true if the module is already loaded or was successfully compiled. Returns false otherwise.Examplesiex&gt; CodeX.ensure_compiled?(Atom) true iex&gt; CodeX.ensure_compiled?(Fake) falseIt wil always return false for none atoms:iex&gt; CodeX.ensure_compiled?(5) false","ref":"CodeX.html#ensure_compiled?/1","title":"CodeX.ensure_compiled?/1","type":"function"},{"doc":"Ensures the given module is loaded.Similar to Code.ensure_loaded/1, but returns true if the module is already loaded or was successfully loaded. Returns false otherwise.Examplesiex&gt; CodeX.ensure_loaded?(Atom) true iex&gt; CodeX.ensure_loaded?(Fake) falseIt wil always return false for none atoms:iex&gt; CodeX.ensure_loaded?(5) false","ref":"CodeX.html#ensure_loaded?/1","title":"CodeX.ensure_loaded?/1","type":"function"},{"doc":"Extensions for common Elixir modules.","ref":"CommonX.html","title":"CommonX","type":"module"},{"doc":"Some enumeration extensions.","ref":"EnumX.html","title":"EnumX","type":"module"},{"doc":"Invokes the given fun for each item in the enumerable. Returns :ok if all calls return :ok, returns {:error, term} if any fail.Examplesiex&gt; EnumX.each([1, 2, 3], fn x -&gt; IO.puts(to_string(x)) end) #=&gt; &quot;1&quot; #=&gt; &quot;2&quot; #=&gt; &quot;3&quot; :okWill halt on first error:iex&gt; EnumX.each([1, 2, 3], fn x -&gt; if x != 2, do: IO.puts(to_string(x)), else: {:error, :is_two} end) #=&gt; &quot;1&quot; {:error, :is_two}","ref":"EnumX.html#each/2","title":"EnumX.each/2","type":"function"},{"doc":"Returns a list where each item is the result of invoking fun on each corresponding item of enumerable. For maps, the function expects a key-value tuple.Examplesiex&gt; EnumX.map([1, 2, 3], fn x -&gt; {:ok, x * 2} end) {:ok, [2, 4, 6]} iex&gt; EnumX.map([a: 1, b: 2], fn {k, v} -&gt; {:ok, {k, -v}} end) {:ok, [a: -1, b: -2]}","ref":"EnumX.html#map/2","title":"EnumX.map/2","type":"function"},{"doc":"Reduces the enumerable until fun returns {:error, reason}.The return value for fun is expected to be{:ok, acc} to continue the reduction with acc as the new accumulator or{:error, acc} to halt the reduction and return acc as the return value of this functionExamplesiex&gt; EnumX.reduce_while(1..100, 0, fn x, acc -&gt; ...&gt; if x &lt; 3, do: {:ok, acc + x}, else: {:error, acc} ...&gt; end) {:error, 3}","ref":"EnumX.html#reduce_while/3","title":"EnumX.reduce_while/3","type":"function"},{"doc":"Macro extension module.","ref":"MacroX.html","title":"MacroX","type":"module"},{"doc":"Properly converts atoms and strings to camelCase. Unlike MacroX.camelize/1, which converts only strings to PascalCase.Examplesiex&gt; MacroX.camelize(:my_atom) :myAtom iex&gt; MacroX.camelize(&quot;my_string&quot;) &quot;myString&quot; iex&gt; MacroX.camelize(&quot;my_ip_address&quot;) &quot;myIPAddress&quot;","ref":"MacroX.html#camelize/1","title":"MacroX.camelize/1","type":"function"},{"doc":"Converts the given string to PascalCase format. This function was designed to pascalize language identifiers/tokens, that's why it belongs to the MacroX module. Do not use it as a general mechanism for pascalizing strings as it does not support Unicode or characters that are not valid in Elixir identifiers.Examplesiex&gt; MacroX.pascalize(&quot;foo_bar&quot;) &quot;FooBar&quot; iex&gt; MacroX.pascalize(:foo_bar) FooBar iex&gt; MacroX.pascalize(&quot;cluster_ip&quot;) &quot;ClusterIP&quot;If uppercase characters are present, they are not modified in any way as a mechanism to preserve acronyms:iex&gt; MacroX.pascalize(&quot;API.V1&quot;) &quot;API.V1&quot; iex&gt; MacroX.pascalize(&quot;API_SPEC&quot;) &quot;API_SPEC&quot;","ref":"MacroX.html#pascalize/1","title":"MacroX.pascalize/1","type":"function"},{"doc":"Converts the given atom or binary to snakize format. If an atom is given, it is assumed to be an Elixir module, so it is converted to a binary and then processed. This function was designed to snakize language identifiers/tokens, that's why it belongs to the Macro module. Do not use it as a general mechanism for underscoring strings as it does not support Unicode or characters that are not valid in Elixir identifiers.Examplesiex&gt; MacroX.snakize(&quot;FooBar&quot;) &quot;foo_bar&quot; iex&gt; MacroX.snakize(&quot;Foo.Bar&quot;) &quot;foo/bar&quot; iex&gt; MacroX.snakize(Foo.Bar) &quot;foo/bar&quot; iex&gt; MacroX.snakize(:FooBar) :foo_barIn general, snakize can be thought of as the reverse of pascalize, however, in some cases formatting may be lost:iex&gt; MacroX.snakize(&quot;SAPExample&quot;) &quot;sap_example&quot; iex&gt; MacroX.pascalize(&quot;sap_example&quot;) &quot;SapExample&quot; iex&gt; MacroX.pascalize(&quot;hello_10&quot;) &quot;Hello10&quot;","ref":"MacroX.html#snakize/1","title":"MacroX.snakize/1","type":"function"},{"doc":"Alias for snakize/1.Exampleiex&gt; MacroX.underscore(&quot;PascalCase&quot;) &quot;pascal_case&quot;","ref":"MacroX.html#underscore/1","title":"MacroX.underscore/1","type":"function"},{"doc":"Some map extensions.","ref":"MapX.html","title":"MapX","type":"module"},{"doc":"Transform the keys of a given map to atoms.Examplesiex&gt; MapX.atomize(%{a: 5}) %{a: 5} iex&gt; MapX.atomize(%{&quot;a&quot; =&gt; 5}) %{a: 5}","ref":"MapX.html#atomize/1","title":"MapX.atomize/1","type":"function"},{"doc":"Transform the keys of a given map to atoms.Examplesiex&gt; MapX.atomize!(%{a: 5}) %{a: 5} iex&gt; MapX.atomize!(%{&quot;a&quot; =&gt; 5}) %{a: 5} iex&gt; MapX.atomize!(%{&quot;non existing&quot; =&gt; 5}) ** (ArgumentError) argument error","ref":"MapX.html#atomize!/1","title":"MapX.atomize!/1","type":"function"},{"doc":"Deletes the entry in map for a specific key.If the key does not exist, returns map unchanged.Inlined by the compiler.Examplesiex&gt; MapX.delete(%{a: 1, b: 2}, :a) %{b: 2} iex&gt; MapX.delete(%{&quot;a&quot; =&gt; 1, &quot;b&quot; =&gt; 2}, :a) %{&quot;b&quot; =&gt; 2} iex&gt; MapX.delete(%{b: 2}, :a) %{b: 2}","ref":"MapX.html#delete/2","title":"MapX.delete/2","type":"function"},{"doc":"Fetches the value for a specific key in the given map. If map contains the given key with value value, then {:ok, value} is returned. If map doesn't contain key, :error is returned. Inlined by the compiler.Examplesiex&gt; MapX.fetch(%{a: 1}, :a) {:ok, 1} iex&gt; MapX.fetch(%{&quot;a&quot; =&gt; 1}, :a) {:ok, 1} iex&gt; MapX.fetch(%{a: 1}, :b) :error","ref":"MapX.html#fetch/2","title":"MapX.fetch/2","type":"function"},{"doc":"Gets the value for a specific key in map.If key is present in map with value value, then value is returned. Otherwise, default is returned (which is nil unless specified otherwise).Examplesiex&gt; MapX.get(%{}, :a) nil iex&gt; MapX.get(%{a: 1}, :a) 1 iex&gt; MapX.get(%{&quot;a&quot; =&gt; 1}, :a) 1 iex&gt; MapX.get(%{a: 1}, :b) nil iex&gt; MapX.get(%{a: 1}, :b, 3) 3","ref":"MapX.html#get/3","title":"MapX.get/3","type":"function"},{"doc":"Merges two maps into one, resolving conflicts through the given fun. All keys in map2 will be added to map1. The given function will be invoked when there are duplicate keys; its arguments are key (the duplicate key), value1 (the value of key in map1), and value2 (the value of key in map2). The value returned by fun is used as the value under key in the resulting map.Examplesiex&gt; MapX.merge(%{a: 1, b: 2}, %{a: 3, d: 4}, fn _k, v1, v2 -&gt; ...&gt; {:ok, v1 + v2} ...&gt; end) {:ok, %{a: 4, b: 2, d: 4}} ````","ref":"MapX.html#merge/3","title":"MapX.merge/3","type":"function"},{"doc":"Creates a map from an enumerable via the given transformation function. Duplicated keys are removed; the latest one prevails.Returning :skip will skip to the next value.Examplesiex&gt; MapX.new([:a, :b], fn x -&gt; {:ok, x, x} end) {:ok, %{a: :a, b: :b}}iex&gt; MapX.new(1..5, &amp;if(rem(&amp;1, 2) == 0, do: :skip, else: {:ok, &amp;1, &amp;1})) {:ok, %{1 =&gt; 1, 3 =&gt; 3, 5 =&gt; 5}}","ref":"MapX.html#new/3","title":"MapX.new/3","type":"function"},{"doc":"Transform the keys of a given map to atoms.Examplesiex&gt; MapX.stringify(%{a: 5}) %{&quot;a&quot; =&gt; 5} iex&gt; MapX.stringify(%{&quot;a&quot; =&gt; 5}) %{&quot;a&quot; =&gt; 5}","ref":"MapX.html#stringify/1","title":"MapX.stringify/1","type":"function"},{"doc":"Updates the key in map with the given function.If key is present in map with value value, fun is invoked with argument value and its result is used as the new value of key. If key is not present in map, then the original map is returned.Examplesiex&gt; MapX.update_if_exists(%{a: 1}, :a, &amp;(&amp;1 * 2)) %{a: 2} iex&gt; MapX.update_if_exists(%{a: 1}, :b, &amp;(&amp;1 * 2)) %{a: 1} iex&gt; MapX.update_if_exists([a: 5], :a, &amp;(&amp;1 * 2)) ** (BadMapError) expected a map, got: [a: 5]","ref":"MapX.html#update_if_exists/3","title":"MapX.update_if_exists/3","type":"function"},{"doc":"CommonX Extension of common Elixir modules.","ref":"readme.html","title":"CommonX","type":"extras"},{"doc":"The package can be installed by adding common_x to your list of dependencies in mix.exs:def deps do [ {:common_x, &quot;~&gt; 0.5&quot;} ] endThe docs can be found at https://hexdocs.pm/common_x.","ref":"readme.html#installation","title":"CommonX - Installation","type":"extras"},{"doc":"The following modules have extension:ApplicationX (Application extension)CodeX (Code extension)EnumX (Enum extension)MapX (Map extension)Macro (Macro extension)","ref":"readme.html#extensions","title":"CommonX - Extensions","type":"extras"},{"doc":"2022-09-07 (v0.5.7 / v0.5.8)Recompile when mix.exs changes.2020-08-12 (v0.5.6)Fix project detection when installed inside a Elixir script with Mix.install/2.2020-11-08 (v0.5.5)Small fix detecting compile environment in custom commands and Elixir &gt;= 1.11.2020-10-08 (v0.5.4)Small fix detecting compile environment.2020-07-02 (v0.5.3)Compile warning fix.2020-05-13 (v0.5.2)Improve ApplicationX.mix_env/0 for newer OTP/Elixir versions.2020-04-05 (v0.5.1)Add ApplicationX.mix_env/0, which returns the current Mix environment.2020-03-15 (v0.5.0)Add CodeX.ensure_compiled?/1, which returns true if the module is already compiled or was successfully compiled.Add CodeX.ensure_loaded?/1, which returns true if the module is already loaded or was successfully loaded.2020-03-08 (v0.4.1)Add ApplicationX.main_project/0, which returns the mix project config of the main application, even when called from dependencies.2020-03-07 (v0.4.0)Add ApplicationX.main/0, which returns the atom of the main application, even when called from dependencies.2020-01-15 (v0.3.0)Add MapX.update_if_exists/3 to update map values, only if the key exists.2019-12-23 (v0.2.3)Fix MapX.new/2 spec.2019-10-12 (v0.2.0)Add ApplicationX extension with the following methods:applications/0 list all applications, without starting.applications/1 list all dependencies, without starting.modules/0 list all modules, without starting applications.modules/1 list all modules in given applications, without starting them.2019-01-01 (v0.0.2)Add MacroX extension with the following methods:camalize/1 proper camelCase for string and atom.pascalize/1 proper PascalCase for string and atom.snakize/1 proper snake_case for string and atom.underscore/1 alias for snakize.","ref":"readme.html#changelog","title":"CommonX - Changelog","type":"extras"}]